/*
 * This product is dual-licensed under both the AGPL 3 and a Commercial License.
 *
 * ssip-footprint - A tool for footprinting molecular electrostatic potential surfaces for calculation of solvation energies.
 * Copyright © 2015 Christopher Hunter (ch664@cam.ac.uk)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ======================================================================
 *
 * Copyright Mark Driver, Christopher Hunter, Teodor Nikolov at the University of Cambridge.
 *
 * Enquiries for any non-academic use of SSIPTools including commercial use should be directed to Cambridge Enterprise:
 *
 * Cambridge Enterprise Ltd
 * University of Cambridge
 * Hauser Forum
 * 3 Charles Babbage Rd
 * Cambridge CB3 0GT
 * United Kingdom
 * Tel: +44 (0)1223 760339
 * Email: software@enterprise.cam.ac.uk
 */
package uk.ac.cam.ch.hunter.ssip.footprint.cli;

import java.util.Arrays;
import java.util.List;

import joptsimple.OptionParser;
import joptsimple.OptionSpecBuilder;

/**
 * Handles logic between commandline options
 *
 * @author mjw
 *
 */
public class FootprintOptionParser extends OptionParser {

	public FootprintOptionParser() {
		// pi function option switch
		OptionSpecBuilder piFunctionOption = acceptsAll(asList("t"), 
		"Use differential MEPS and pi-function. This requires 3 MEPS surfaces to run.");
		// input options for files.
		OptionSpecBuilder cmlFile = acceptsAll(asList("c", "cml"),
				"The CML file of the corresponding molecule in the cube file.");
		cmlFile.withRequiredArg().ofType(String.class);
		
		OptionSpecBuilder mainCubeFile = acceptsAll(asList("m", "cube"),
				"The cube file for the MEPS corresponding to the molecule, generated by the QM tool. At 0.002 a.u. isosurface.");
		mainCubeFile.withRequiredArg().ofType(String.class);

		OptionSpecBuilder piGradInner = acceptsAll(asList("g", "grad-inner"),
					"the isout file for the 0.005 a.u. isosurface, used for beta determination");
		piGradInner.withRequiredArg().ofType(String.class);
		piGradInner.requiredIf(piFunctionOption);
		OptionSpecBuilder piFPInner = acceptsAll(asList("f", "fp-inner"),
				"the isout file for the 0.0104 a.u. isosurface, used for footprinting");
		piFPInner.withRequiredArg().ofType(String.class);
		piFPInner.requiredIf(piFunctionOption);
		// inputs to select the mode to run the calculation.
		
		OptionSpecBuilder nonInt = acceptsAll(asList("n"), "Function in a non-interactive mode.");
		OptionSpecBuilder writeToXmlFile = acceptsAll(asList("w"),
				"Write the molecule and SSIP information to a file using an XML format.");
		writeToXmlFile.withRequiredArg().ofType(String.class);

		// Options to do with selection of SSIPs and footprinting parameters
		OptionSpecBuilder selector = acceptsAll(asList("selector"), "Sets with selector will be used to find SSIPs on molecule.");
		selector.withRequiredArg().defaultsTo("ORIGINAL");
		OptionSpecBuilder footprintParameters = acceptsAll(asList("params"), "Flag required to select input of footprinting parameters.");

		OptionSpecBuilder surfaceArea = acceptsAll(asList("surfacearea"), "This parameter sets the surface area of an SSIP to be used. Defaults to 9.35A^2");
		surfaceArea.withRequiredArg().ofType(Double.class).defaultsTo(9.35);
		surfaceArea.availableIf(footprintParameters);
		OptionSpecBuilder lowerCutOffDistance = acceptsAll(asList("dtotal"), "Parameter for distance between SSIPs on surface.");
		lowerCutOffDistance.withRequiredArg().ofType(Double.class).defaultsTo(3.2);
		lowerCutOffDistance.availableIf(footprintParameters);
		OptionSpecBuilder posLowerCutOffDistance = acceptsAll(asList("dpos"), "Parameter for distance between SSIPs on positive surface.");
		posLowerCutOffDistance.withRequiredArg().ofType(Double.class);
		posLowerCutOffDistance.availableIf(footprintParameters);
		posLowerCutOffDistance.availableUnless(lowerCutOffDistance);
		OptionSpecBuilder negLowerCutOffDistance = acceptsAll(asList("dneg"), "Parameter for distance between SSIPs on negative surface.");
		negLowerCutOffDistance.withRequiredArg().ofType(Double.class);
		negLowerCutOffDistance.availableIf(footprintParameters);
		negLowerCutOffDistance.availableUnless(lowerCutOffDistance);
		
		OptionSpecBuilder scaledOccludedDistance = acceptsAll(asList("rscale"), "This uses a scaled distance to be used for occluded zone.");
		scaledOccludedDistance.availableIf(footprintParameters);
		OptionSpecBuilder totalOccludedDistance = acceptsAll(asList("rtotal"), "This is the total occluded zone distance");
		totalOccludedDistance.withRequiredArg().ofType(Double.class).defaultsTo(1.1);
		totalOccludedDistance.availableIf(footprintParameters);
		totalOccludedDistance.availableUnless(scaledOccludedDistance);
		OptionSpecBuilder posOccludedDistance = acceptsAll(asList("rpos"), "This is the occluded zone distance for positive surface");
		posOccludedDistance.withRequiredArg().ofType(Double.class);
		posOccludedDistance.availableIf(footprintParameters).availableUnless(scaledOccludedDistance, totalOccludedDistance);
		OptionSpecBuilder negOccludedDistance = acceptsAll(asList("rneg"), "This is the occluded zone distance for negative surface");
		negOccludedDistance.withRequiredArg().ofType(Double.class);
		negOccludedDistance.availableIf(footprintParameters).availableUnless(scaledOccludedDistance, totalOccludedDistance);
		
		
		// help option.
		OptionSpecBuilder help = acceptsAll(asList("h", "?", "help"), "Display this output.");
		help.forHelp();

	}

	@SafeVarargs
	private static <T> List<T> asList(T... items) {
		return Arrays.asList(items);
	}

}
